<!-- Displays all matches for one team. -->

{% extends 'main/base.html' %}
{% load static %}
{% load scouting_extras %}

{% block stylesheets %}
<link rel="stylesheet" href="{% static 'scouting/css/indexTeamAll.css' %}">
{% endblock %}

{% block js %}
<script type="text/javascript" src="{% static 'scouting/js/search.js' %}"></script>
{% endblock %}

{% block nav_home %} class="button" {% endblock %}
{% block nav_scouting %} class="button-selected" {% endblock %}
{% block nav_contact %} class="button" {% endblock %}
{% block nav_sign-in %} class="button" {% endblock %}

{% block content %}

  <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
  <script type="text/javascript">
    google.charts.load('current', {packages: ['corechart']});
    google.charts.setOnLoadCallback(hatchChart);
    google.charts.setOnLoadCallback(cargoChart);
    google.charts.setOnLoadCallback(sandstormChart);
    google.charts.setOnLoadCallback(climbingChart);
    google.charts.setOnLoadCallback(hatchCargoChart);

    function hatchChart() {
      var data = new google.visualization.DataTable();
      data.addColumn('string', 'Position');
      data.addColumn('number', 'Hatches');
      data.addRows([
        ['Rocket 1', {{ AR1H }}],
        ['Rocket 2', {{ AR2H }}],
        ['Rocket 3', {{ AR3H }}],
        ['Cargo Ship', {{ ACSH }}],
      ]);

      // Set chart options
      var options = {'title':'Average Hatches by Position'};

      // Instantiate and draw our chart, passing in some options.
      var chart = new google.visualization.PieChart(document.getElementById('hatch_chart'));
      chart.draw(data, options);
    }
    
    function cargoChart() {
      var data = new google.visualization.DataTable();
      data.addColumn('string', 'Position');
      data.addColumn('number', 'Cargo');
      data.addRows([
        ['Rocket 1', {{ AR1B }}],
        ['Rocket 2', {{ AR2B }}],
        ['Rocket 3', {{ AR3B }}],
        ['Cargo Ship', {{ ACSB }}],
      ]);

      // Set chart options
      var options = {'title':'Average Cargo by Position'};

      // Instantiate and draw our chart, passing in some options.
      var chart = new google.visualization.PieChart(document.getElementById('cargo_chart'));
      chart.draw(data, options);
    }
    
    function sandstormChart() {
      var data = new google.visualization.DataTable();
      data.addColumn('string', 'Scoring');
      data.addColumn('number', 'Number');
      data.addRows([
        ['Rocket Hatches', {{ ASRH }}],
        ['Rocket Cargo', {{ ASRB }}],
        ['Cargo Ship Hatches', {{ ASCSH }}],
        ['Cargo Ship Cargo', {{ ASCSB }}],
      ]);

      // Set chart options
      var options = {'title':'Sandstorm'};

      // Instantiate and draw our chart, passing in some options.
      var chart = new google.visualization.PieChart(document.getElementById('sandstorm_chart'));
      chart.draw(data, options);
    }
    
    function climbingChart() {
      var data = new google.visualization.DataTable();
      data.addColumn('string', 'Level');
      data.addColumn('number', 'Number of reaches');
      data.addRows([
        ['Did not climb', {{ ALL_CLIMBS|index:0 }}],
        ['Level 1', {{ ALL_CLIMBS|index:1 }}],
        ['Attemped Level 2', {{ ALL_CLIMBS|index:2 }}],
        ['Level 2', {{ ALL_CLIMBS|index:3 }}],
        ['Attemped Level 3', {{ ALL_CLIMBS|index:4 }}],
        ['Level 3', {{ ALL_CLIMBS|index:5 }}],
      ]);

      // Set chart options
      var options = {'title':'Climbing'};

      // Instantiate and draw our chart, passing in some options.
      var chart = new google.visualization.PieChart(document.getElementById('climbing_chart'));
      chart.draw(data, options);
    }
    
    function hatchCargoChart() {
      var data = new google.visualization.DataTable();
      data.addColumn('string', 'Scoring');
      data.addColumn('number', 'Number');
      data.addRows([
        ['Hatches', {{ ASRH }} + {{ ASCSH }} + {{ AR1H }} + {{ AR2H }} + {{ AR3H }} + {{ ACSH }}],
        ['Cargo', {{ ASRB }} + {{ ASCSB }} + {{ AR1B }} + {{ AR2B }} + {{ AR3B }} + {{ ACSB }}],
      ]);

      // Set chart options
      var options = {'title':'Hatches & Cargo'};

      // Instantiate and draw our chart, passing in some options.
      var chart = new google.visualization.PieChart(document.getElementById('hatch_cargo_div'));
      chart.draw(data, options);
    }
  </script>
        
        <!-- Delete these line breaks when the CSS is fixed so that stuff isn't hidden by the top bar -->
        <br><br><br><br><br><br>

<div class = "content"> 
    
    <a href="{% url 'scouting:index' %}" class = "match-button"> <i class="fas fa-caret-left"></i> Back to Index</a>

    {% if team %}

        <div class = "team-header"> Team {{ team }} </div>
    {% else %}
        <div class = "team-header"> Team [Number not found] </div>
    {% endif %}
        
    {% if avg %}
        <h3 class = "average-score"> <span class = "grey-text"> Average Score: </span> {{ avg }} </h3>
    {% else %}
        <h1> No matches have been entered </h1>
    {% endif %}
    
    {% if matches and team %}
    
      <!-- Chart divs go here -->
    <div class = "charts"> 
      <div id="hatch_chart"></div>
      <div id="cargo_chart"></div>
      <div id="sandstorm_chart"></div>
      <div id="climbing_chart"></div>
      <div id="hatch_cargo_div"></div>
    </div>
        <h2 class = "matches">All Matches</h2>
        <ul>
          
        <div class="search-bar">
            <h1><i class="fas fa-search"></i></h1>
            <input id="search-input" type="text" placeholder='Search Competitions..' onkeyup="myFunction()">
        </div>
        
            <div style="overflow-x:auto;">
                <table id = "matchTable">
                  <tr>
                    <th onclick="sortTable(0)" class = "highlightedCell"> <div class = "inline"> Competition <i class="fas fa-sort"> </i> </div> </th>
                    <th onclick="sortTable(1)"> <div class = "inline"> Match <i class="fas fa-sort"> </i> </div>
                    <th onclick="sortTable(2)"> <div class = "inline"> Start <i class="fas fa-sort"> </i> </div> </th>
                    <th onclick="sortTable(3)"> <div class = "inline"> S.R Hatches <i class="fas fa-sort"> </i> </div> </th>
                    <th onclick="sortTable(4)"> <div class = "inline"> S.R Cargo <i class="fas fa-sort"> </i> </div> </th>
                    <th onclick="sortTable(5)"> <div class = "inline"> S. CS. Hatches <i class="fas fa-sort"> </i> </div> </th>
                    <th onclick="sortTable(6)"> <div class = "inline"> S. CS. Cargo <i class="fas fa-sort"> </i> </div> </th>
                    <th onclick="sortTable(7)"> <div class = "inline"> R.1 Hatches <i class="fas fa-sort"> </i> </div> </th>
                    <th onclick="sortTable(8)"> <div class = "inline"> R.1 Cargo <i class="fas fa-sort"> </i> </div></th>
                    <th onclick="sortTable(9)"> <div class = "inline"> R.2 Hatches <i class="fas fa-sort"> </i> </div> </th>
                    <th onclick="sortTable(10)"> <div class = "inline"> R.2 Cargo <i class="fas fa-sort"> </i> </div> </th>
                    <th onclick="sortTable(11)"> <div class = "inline"> R.3 Hatches <i class="fas fa-sort"> </i> </div> </th>
                    <th onclick="sortTable(12)"> <div class = "inline"> R.3 Cargo <i class="fas fa-sort"> </i> </div> </th>
                    <th onclick="sortTable(13)"> <div class = "inline"> CS. Hatches <i class="fas fa-sort"> </i> </div> </th>
                    <th onclick="sortTable(14)"> <div class = "inline"> CS. Cargo <i class="fas fa-sort"> </i> </div> </th>
                    <th onclick="sortTable(15)"> <div class = "inline"> Climbing <i class="fas fa-sort"> </i> </div> </th>
                  </tr>
                    <tr>
                      <td class = "average">Averages:</td>
                      <td class = "average">---</td>
                      <td class = "average">---</td>
                      <td class = "average">{{ ASRH }}</td>
                      <td class = "average">{{ ASRB }}</td>
                      <td class = "average">{{ ASCSH }}</td>
                      <td class = "average">{{ ASCSB }}</td>
                      <td class = "average">{{ AR1H }}</td>
                      <td class = "average">{{ AR1B }}</td>
                      <td class = "average">{{ AR2H }}</td>
                      <td class = "average">{{ AR2B }}</td>
                      <td class = "average">{{ AR3H }}</td>
                      <td class = "average">{{ AR3B }}</td>
                      <td class = "average">{{ ACSH }}</td>
                      <td class = "average">{{ ACSB }}</td>
                      <td class = "average">---</td>
                    </tr>
                    {% for m in matches %}
                    <tr>
                        <td><u><li><a class = "view" href="{% url 'scouting:indexComp' m.Competition.id %}">{{ m.Competition.Name }}</a></li></u></td>
                        <td><u><li><a class = "view" href="{% url 'scouting:detailed' m.Competition.id m.id %}">Match {{ m.MatchNum }}</a></li></u></td>
                        <td>{{ m.Start }}</td>
                        <td>{{ m.Rocket_Hatch_Sandstorm }}</td>
                        <td>{{ m.Rocket_Ball_Sandstorm }}</td>
                        <td>{{ m.CargoShip_Hatch_Sandstorm }}</td>
                        <td>{{ m.CargoShip_Ball_Sandstorm }}</td>
                        <td>{{ m.Rocket_L1_Hatch }}</td>
                        <td>{{ m.Rocket_L1_Ball }}</td>
                        <td>{{ m.Rocket_L2_Hatch }}</td>
                        <td>{{ m.Rocket_L2_Ball }}</td>
                        <td>{{ m.Rocket_L3_Hatch }}</td>
                        <td>{{ m.Rocket_L3_Ball }}</td>
                        <td>{{ m.CargoShip_Hatch }}</td>
                        <td>{{ m.CargoShip_Ball }}</td>
                        <td>{{ m.Climb }}</td>
                    </tr> 
                    {% endfor %}
                    
                </table>
            </div>
        </ul>
        
    {% else %}
        <p class = "no-data"> No data is available, or there has been an error. Contact programming if this message appears after data has been entered.</p>
    {% endif %}
    

</div>

<script>
function sortTable(n) {
  var table, rows, switching, i, j, x, y, cell, shouldSwitch, dir, switchcount = 0;
  table = document.getElementById("matchTable");
  switching = true;
  // Set the sorting direction to ascending:
  dir = "asc"; 
      rows = table.rows;
      // Change the appearance of the selected header
      for (j = 0; j < rows[0].cells.length; j++) {
        cell = rows[0].cells[j];
        console.log(cell);
        
        if(j == n) {
          //set the cell class to change appearance
          cell.classList.add("highlightedCell");
        } else {
          //remove the cell class
          cell.classList.remove("highlightedCell");
        }
      }
  /* Make a loop that will continue until
  no switching has been done: */
  while (switching) {
    // Start by saying: no switching is done:
    switching = false;
    rows = table.rows;
    /* Loop through all table rows (except the
    first, which contains table headers): */
    for (i = 2; i < (rows.length - 1); i++) {
          // Start by saying there should be no switching:
          shouldSwitch = false;
          /* Get the two elements you want to compare,
          one from current row and one from the next: */
          x = rows[i].getElementsByTagName("TD")[n];
          y = rows[i + 1].getElementsByTagName("TD")[n];
          /* Check if the two rows should switch place,
          based on the direction, asc or desc: */
          if (dir == "asc" && n > 1) {
            if (parseFloat(x.textContent.toLowerCase()) < parseFloat(y.textContent.toLowerCase())) {
              // If so, mark as a switch and break the loop:
              shouldSwitch = true;
              break;
            }
          } else if (dir == "desc" && n > 1) {
            if (parseFloat(x.textContent.toLowerCase()) > parseFloat(y.textContent.toLowerCase())) {
              // If so, mark as a switch and break the loop:
              shouldSwitch = true;
              break;
            }
          } else if (dir == "asc" && n == 1) {
            if (parseFloat(x.textContent.substring(6).toLowerCase()) < parseFloat(y.textContent.substring(6).toLowerCase())) {
              // If so, mark as a switch and break the loop:
              shouldSwitch = true;
              break;
            }
          } else if (dir == "desc" && n == 1) {
            if (parseFloat(x.textContent.substring(6).toLowerCase()) > parseFloat(y.textContent.substring(6).toLowerCase())) {
              // If so, mark as a switch and break the loop:
              shouldSwitch = true;
              break;
            }
          } else if (dir == "asc" && n == 0) {
            if (x.textContent.toLowerCase() < y.textContent.toLowerCase()) {
              // If so, mark as a switch and break the loop:
              shouldSwitch = true;
              break;
            }
          } else if (dir == "desc" && n == 0) {
            if (x.textContent.toLowerCase() > y.textContent.toLowerCase()) {
              // If so, mark as a switch and break the loop:
              shouldSwitch = true;
              break;
            }
          } 
        }
    if (shouldSwitch) {
      /* If a switch has been marked, make the switch
      and mark that a switch has been done: */
      rows[i].parentNode.insertBefore(rows[i + 1], rows[i]);
      switching = true;
      // Each time a switch is done, increase this count by 1:
      switchcount ++; 
    } else {
      /* If no switching has been done AND the direction is "asc",
      set the direction to "desc" and run the while loop again. */
      if (switchcount == 0 && dir == "asc") {
        dir = "desc";
        switching = true;
      }
    }
  }
}
</script>
{% endblock %}